
void  Interrupt_Init(void)
{
    bool state = (unsigned char)  INTCON0bits.GIE;
    INTCON0bits.GIE=0;
    INTCON0bits.IPEN = 1;
    INTCON0bits.GIEH = 0; // dis high priority interrupts
    INTCON0bits.GIEL = 0; // dis low priority interrupts*
     
    INTCON0bits.IPEN = 1; // Enable interrupt priority
   //  __asm("BCF INTCON0,GIE");
   // GIE = 0;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x00; // unlock IVT
    IVTBASEU = 0;
    IVTBASEH = 0;
    IVTBASEL = 8;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x01; // lock IVT
    // Assign peripheral interrupt priority vectors
    IPR3bits.U1RXIP = 1;
    IPR1bits.INT0IP = 1;
    IPR4bits.TMR1IP = 0;
    IPR3bits.TMR0IP = 0;
    IPR4bits.TMR2IP = 0;  // low priority
    IPR7bits.TMR4IP = 0;
    IPR9bits.TMR6IP = 0;
    IPR0bits.IOCIP =  0;
    INTCON0bits.GIEL = 1; // Enable low priority interrupts
    INTCON0bits.GIEH = 1; // dis high priority interrupts
    INTCON0bits.GIE= state;
}